local AddonName = ...
local actionAura  = LibStub("AceAddon-3.0"):GetAddon(AddonName)

local events = {
		"PET_BAR_UPDATE_USABLE",
		"PET_UI_UPDATE",
		"UNIT_AURA",
		"UNIT_COMBAT",
		"UNIT_PET",
		"UNIT_SPELLCAST_SENT",
		"UNIT_ENTERED_VEHICLE",
		"UNIT_HEALTH",
		"UNIT_TARGET",
		"PLAYER_FOCUS_CHANGED",
}

function actionAura:OnInitialize()
	if not self.eventHandler then
		self:RegisterVariables(reset)

		hooksecurefunc("ActionButton_UpdateCooldown", function(actionButton)
			if self.UpdateActionAura then
				self:UpdateActionAura(actionButton)
			end
		end)
		
		if CooldownFrame_Set then
			--Bartender4 Support
			hooksecurefunc("CooldownFrame_Set", function(cd)
				if self.UpdateActionAura then
					self:UpdateActionAura(cd:GetParent())
				end
			end)
		end

		--the following is for fringe cases
		self.eventHandler = CreateFrame("Frame")
		for _, event in pairs(events) do
			self.eventHandler:RegisterEvent(event)
		end

		self.eventHandler:SetScript("OnEvent", function()
			if self.GetButtons then
				for _, button in pairs(self:GetButtons()) do
					self:UpdateActionAura(button)
				end
			end
		end)
	end
end
